G_AddGametype({
    name = "Battle",
    identifier = "battle",
    typeoflevel = TOL_MATCH|TOL_BATTLE,
    rules = GTR_SPECTATORS|GTR_POINTLIMIT|GTR_TIMELIMIT|GTR_SPAWNINVUL|GTR_DEATHPENALTY|GTR_DEATHMATCHSTARTS|GTR_HURTMESSAGES,
    rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 6,
    headerleftcolor = 56,
    headerrightcolor = 56,
    description = 'Bash other players with your spin and jump moves to earn points! Collect and use rings to unleash special moves unique to each character!'
})

G_AddGametype({
    name = "Team Battle",
    identifier = "teambattle",
    typeoflevel = TOL_MATCH|TOL_BATTLE,
    rules = GTR_TEAMS|GTR_SPECTATORS|GTR_POINTLIMIT|GTR_TIMELIMIT|GTR_SPAWNINVUL|GTR_DEATHPENALTY|GTR_DEATHMATCHSTARTS|GTR_HURTMESSAGES,
    rankingtype = GT_TEAMMATCH,
	intermissiontype = int_teammatch,
	defaultpointlimit = 0,
	defaulttimelimit = 6,
    headerleftcolor = 150,
    headerrightcolor = 37,
    description = 'Stick together! The team that can support each other and deal the most damage will be victorious!'
})

G_AddGametype({
    name = "Egg Robo Tag",
    identifier = "eggrobotag",
    typeoflevel = TOL_MATCH|TOL_BATTLE|TOL_EGGROBOTAG,
    rules = GTR_TAG|GTR_STARTCOUNTDOWN|GTR_BLINDFOLDED|GTR_POINTLIMIT|GTR_TIMELIMIT|GTR_SPAWNINVUL|GTR_DEATHMATCHSTARTS|GTR_HURTMESSAGES,
    rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 5,
    headerleftcolor = 39,
    headerrightcolor = 11,
    description = "Uh-oh! Eggman has sent one of his henchmen to roboticize Sonic and his friends. Don't get caught, or you'll turn into an Egg-Robo too!"
})

G_AddGametype({
    name = "Battle CTF",
    identifier = "battlectf",
    typeoflevel = TOL_CTF|TOL_BATTLECTF,
    rules = GTR_TEAMFLAGS|GTR_TEAMS|GTR_SPECTATORS|GTR_POINTLIMIT|GTR_TIMELIMIT|GTR_SPAWNINVUL|GTR_DEATHPENALTY|GTR_OVERTIME|GTR_HURTMESSAGES,
    rankingtype = GT_CTF,
	intermissiontype = int_ctf,
	defaultpointlimit = 3,
	defaulttimelimit = 10,
    headerleftcolor = 37,
    headerrightcolor = 150,
    description = "Combine melee and special moves to capture the enemy flag while protecting your own. Master the slipstream to catch up to enemy flagrunners!"
})

G_AddGametype({
    name = "Control Point",
    identifier = "cp",
    typeoflevel = TOL_MATCH|TOL_CP,
    rules = GTR_SPECTATORS|GTR_POINTLIMIT|GTR_TIMELIMIT|GTR_SPAWNINVUL|GTR_DEATHPENALTY|GTR_DEATHMATCHSTARTS|GTR_HURTMESSAGES,
    rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 5000,
	defaulttimelimit = 10,
    headerleftcolor = 75,
    headerrightcolor = 75,
    description = "The player who stands inside the score zone for long enough will claim its reward! Knock your foes out before they steal the spotlight!"
})

G_AddGametype({
    name = "Team Control Point",
    identifier = "teamcp",
    typeoflevel = TOL_MATCH|TOL_CP,
    rules = GTR_TEAMS|GTR_SPECTATORS|GTR_POINTLIMIT|GTR_TIMELIMIT|GTR_SPAWNINVUL|GTR_DEATHPENALTY|GTR_DEATHMATCHSTARTS|GTR_HURTMESSAGES,
    rankingtype = GT_TEAMMATCH,
	intermissiontype = int_teammatch,
	defaultpointlimit = 3,
	defaulttimelimit = 10,
    headerleftcolor = 37,
    headerrightcolor = 150,
    description = "Players must work together to capture the control point before the opposing team does. The more players inside, the faster the capture!"
})