local B = CBW_Battle
local CV = B.Console
B.ActionChar["sonic"] = B.Action.SuperSpinJump
B.ActionChar["tails"] = B.Action.Sentry
B.ActionChar["knuckles"] = B.Action.Dig
B.ActionChar["amy"] = B.Action.CharmBeam
B.ActionChar["fang"] = B.Action.BombThrow
B.ActionChar["metalsonic"] = B.Action.ChargeBlast
B.ActionChar["tageggrobo"] = B.Action.TagEggRobo

B.MasterActionScript = function(player,doaction,throwring,tossflag)
	if G_RingSlingerGametype() then return false end
	if not(CV.Actions.value) then return false end
	local mo = player.mo
	if not(mo and mo.valid and mo.player and mo.player.valid) then return end
	
	if doaction and (
		player.actioncooldown
		or player.exiting
		or player.pflags&PF_STASIS
		or not(player.actionallowed)
		) then
		if doaction == 1 then
			doaction = -1
		else
			doaction = 0
		end
	end

	//Get actiontype
	if player.pflags&PF_TAGIT then player.actiontype = "tageggrobo"
	elseif mo.player.actiontype != mo.skin then
		player.actiontype = mo.skin
		B.ResetPlayerProperties(mo.player,false,false)
		mo.player.actiontext = nil
		mo.player.action2text = nil
		mo.player.actionrings = 0
		mo.player.action2rings = 0
	end
	
	local t = player.actiontype
	if player.disableringslinger then player.weapondelay = 2 end
	mo.player.actiontextflags = nil
	mo.player.action2textflags = nil
	if B.ActionChar[t] != nil then
		B.ActionChar[t](mo,doaction,throwring,tossflag)
		//For custom characters
		if mo.player.spendrings == 1 then
			mo.player.spendrings = 0
			B.PayRings(mo.player)
		elseif (doaction == -1 or mo.player.spendrings == -1) then
			mo.player.spendrings = 0
			S_StartSound(mo,sfx_s3k8c,player)
		end
	else
		mo.player.actiontext = nil
		mo.player.action2text = nil
		mo.player.actionrings = 0
		mo.player.action2rings = 0
	end
	//Action successful
	return true
end