local B = CBW_Battle

B.DummyTeleport = function(mo)
	if not(mo.target and mo.target.valid) then return end
	local t = mo.target
	local a = mo.target.angle
	local d = FRACUNIT
	local x = t.x + P_ReturnThrustX(t,a+ANGLE_180,d)
	local y = t.y + P_ReturnThrustY(t,a+ANGLE_180,d)
	local z = t.z
	P_TeleportMove(mo,x,y,z)
end

B.SpawnTargetDummy = function(player)
	if (not(player.truemo) or not(player.truemo.valid)) then 
		local p = B.UpdatePlayerTrueMobjs()
	end
	local ptmo = player.truemo
	if not(ptmo and ptmo.valid) then return end
	//Game modes
	if B.BattleGametype() and (player.targetdummy == nil or not(player.targetdummy.valid)) then
		//Create target dummy
		player.targetdummy = P_SpawnMobj(ptmo.x,ptmo.y,ptmo.z,MT_TARGETDUMMY)
		player.targetdummy.target = ptmo
		player.targetdummy.flags2 = $|MF2_DONTDRAW
	end
end

//-MobjFlip for Overlays-
B.JetThink = function(mo)
	if not(mo and mo.valid) or mo.health == 0 or (mo.target and mo.target.valid and mo.target.target and mo.target.target.valid and mo.target.target.player and mo.target.target.player.playerstate == PST_DEAD) then
		P_RemoveMobj(mo)
	return end
	if mo.target and mo.target.valid and mo.target.target and mo.target.target.valid and mo.target.target and mo.target.target.flags2&MF2_OBJECTFLIP then
		mo.flags2= $|MF2_OBJECTFLIP
	else
		mo.flags2 = $&~MF2_OBJECTFLIP
	end
	mo.flags = $&~MF_NOGRAVITY
	mo.momz = 0
end

B.DummySpawnLimbs = function(mo,target)
	local limb
	//Gun
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOTAGGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOTAGGIBLET1)
		P_InstaThrust(limb,target.angle-ANGLE_45,limb.scale*5)
		P_SetObjectMomZ(limb,FRACUNIT*7,false)
		limb.fuse = TICRATE
	end
	//Left Arm
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOTAGGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOTAGGIBLET2)
		P_InstaThrust(limb,target.angle-ANGLE_90,limb.scale*5)
		P_SetObjectMomZ(limb,FRACUNIT*5,false)
		limb.fuse = TICRATE
	end
	//Right arm
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOTAGGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOTAGGIBLET3)
		P_InstaThrust(limb,target.angle+ANGLE_90,limb.scale*5)
		P_SetObjectMomZ(limb,FRACUNIT*5,false)
		limb.fuse = TICRATE
	end
	//Left leg
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOTAGGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOTAGGIBLET4)
		P_InstaThrust(limb,target.angle-ANGLE_90,limb.scale*3)
		P_SetObjectMomZ(limb,FRACUNIT*3,false)
		limb.fuse = TICRATE
	end
	//Right leg
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOTAGGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOTAGGIBLET5)
		P_InstaThrust(limb,target.angle+ANGLE_90,limb.scale*3)
		P_SetObjectMomZ(limb,FRACUNIT*3,false)
		limb.fuse = TICRATE
	end
end

//-EggRobo Overlay-
B.DummyEggRobo = function(mo,target)
	if mo.tagged == nil then
		if not(target.player.iseggrobo) then
			A_BossJetFume(mo,4)
			target.player.iseggrobo = true
		end
		mo.tagged = true
		if target.health == 0 and P_MobjFlip(target)*target.momz < 0 then target.player.iseggrobo = false end
		target.player.charflags = $|SF_MACHINE
	end
	if target.player.iseggrobo and target.player.playerstate == PST_DEAD then 
		target.player.iseggrobo = false
		B.DummySpawnLimbs(mo,target)
	end

	B.DummyTeleport(mo)
	mo.flags2 = $&~MF2_DONTDRAW
	target.flags2 = $|MF2_DONTDRAW
	mo.color = target.color

	if target.player.playerstate == PST_DEAD then
		P_SetMobjStateNF(mo,S_EGGROBODEAD)
	return end
	
	B.JetThink(mo)

	if not(skins["eggrobo"])
		if P_PlayerInPain(target.player) or target.player.playerstate == PST_DEAD then
			P_SetMobjStateNF(mo, S_EGGROBOTAG2)
		else
			P_SetMobjStateNF(mo, S_EGGROBOTAG1)
		end
	else
		if P_PlayerInPain(target.player) or target.player.playerstate == PST_DEAD then
			P_SetMobjStateNF(mo, S_EGGROBOALT2)
		else
			P_SetMobjStateNF(mo, S_EGGROBOALT1)
		end
	end
	if mo.target.player.powers[pw_flashing]&1 and not(P_PlayerInPain(target.player)) then mo.flags2 = $|MF2_DONTDRAW end
	if mo.target.player.actionstate != 2 then
		mo.angle = target.angle
	end
end

//-Spectator Flicky Overlay-
B.DummyFlicky = function(mo,target)
	if not(mo.bird) then
		mo.bird = true
		mo.flags2 = $&~MF2_DONTDRAW
		mo.state = S_SPECBIRD1
		mo.flags = $|MF_NOGRAVITY
	end
	mo.angle = target.angle
	mo.momx = (target.x-mo.x)/16
	mo.momy = (target.y-mo.y)/16
	local h = mo.scale*16
	mo.momz = min(max($+(target.z+h-mo.z)/16,-mo.scale*6),mo.scale*6)
	if abs(target.z+h-mo.z) < mo.scale*12 then
		mo.momz = min(max($,-mo.scale),mo.scale)
	end
end

//-Lock on Object-
B.DummyLockOn = function(mo,target)
	mo.height = target.height
	mo.scale = target.scale
	mo.flags = $|MF_NOGRAVITY
	if target.player.playerstate == PST_LIVE then
		B.DummyTeleport(mo) //Reposition
	end
	
	//Get simple lock-on
	for myplayer in players.iterate
		if splitscreen then return end
		if not(myplayer == consoleplayer and myplayer.mo and mo.target != myplayer.mo and myplayer.playerstate == PST_LIVE) then continue end
		if P_CheckSight(myplayer.mo, mo) then
			mo.flags2 =$&~MF2_FRET
		else
			mo.flags2 = $|MF2_FRET
		end
	end
	
	//Get aimable
	if target.player.playerstate == PST_LIVE
		and
		not(target.flags&MF_NOCLIPTHING) then
		mo.flags2 = $|MF2_INVERTAIMABLE //Allow lock-on
	else
		//Target is not alive. Disallow lock-on.
		mo.flags2 = $&~(MF2_INVERTAIMABLE|MF2_FRET)
	end
end

//-Master TargetDummy-
B.TargetDummyThinker = function(mo)
	//Check if target is valid and a player object
	local target = mo.target
	if target and target.valid and target.player
		if (target.player.spectator) and (target.player.playerstate == PST_LIVE) then
			B.DummyFlicky(mo,target) //Spectator flicky
		elseif (target.player.pflags&PF_TAGIT) then //Tag Eggrobo
			if P_PlayerInPain(target.player) and not(mo.tagged) then //Transforming
				if target.colorized == false then
					target.colorized = true
					S_StartSound(nil,sfx_cdfm44)
				end
				target.color = P_RandomRange(1,MAXSKINCOLORS-1)
			else //Transformed
				target.color = target.player.skincolor
				target.colorized = false
				B.DummyEggRobo(mo,target) 
			end
		else
			B.DummyLockOn(mo,target) //Lock-on object
		end
	else //Target was assigned but is now invalid. Remove object.
		P_RemoveMobj(mo)
	end
end

B.DamageTargetDummy = function(target,inflictor,source,damage,other)
	local pmo = target.target
	if pmo and pmo.player then
		local player = pmo.player
		if inflictor and inflictor.player
-- 			and not(B.MyTeam(player,source.player)) and B.PlayerCanBeDamaged(player)
			then
			P_DamageMobj(pmo,inflictor,source,DMG_NUKE)
		end
	end
end