local B = CBW_Battle


B.TagIndicatorHide = function(mo)
-- 	if 1 then return end
-- 	print(0)
	if gametype == GT_EGGROBOTAG then
		mo.flags2 = $|MF2_DONTDRAW
-- 		print(1) return
	end
-- 	print(2)
end

B.TagVictorCheck = function()
	local playercount = 0
	local downcount = 0
	
	for player in players.iterate
		local pmo = player.mo
		
		if gametype != GT_EGGROBOTAG or leveltime < 30*TICRATE then
			player.willbeeggrobo = false
		end
		//Check for spectators
		if (player.spectator or not(player.playerstate == PST_LIVE)) and gametype == GT_EGGROBOTAG and leveltime > TICRATE*30 then
			player.willbeeggrobo = true
		end

		if player.spectator then
			player.pflags = $&~PF_TAGIT
		end
		
		if not(player.spectator) and player.playerstate == PST_LIVE and player.willbeeggrobo then
			player.willbeeggrobo = false
			player.iseggrobo = true
			player.pflags = $|PF_TAGIT
			print(player.name.." is now IT!")
		end
		
		player.buttonhistory = player.cmd.buttons
		
		//Get player counts
		if player.mo and player.mo.valid and not(player.spectator)
			playercount = $+1
			if player.pflags&PF_TAGIT then
				downcount = $+1
			end
		end
		//Validity check
		if not(player.mo and player.mo.valid and player.playerstate == PST_LIVE)
			player.actionstate = 0
			player.buttonhistory = player.cmd.buttons
		end
	end
	
	//Gamemode win condition check
	if downcount == playercount and playercount > 1 then 
		G_ExitLevel()
		return true
	end
	return false
end

B.TagNakedHit = function(mo,missile,owner,knockback)
	if not(B.TagGametype()) then return false end
	mo.player.pflags = $|PF_TAGIT
	local naked = not(mo.player.rings or mo.player.powers[pw_shield])
	if not(naked) then return false end
	if knockback != false then
		P_DoPlayerPain(mo.player,missile,owner)
		P_PlayDeathSound(mo,mo.player)
	end
	P_AddPlayerScore(owner.player,100)
	return true
end
