local B = CBW_Battle
local N = B.NetVars
local CV = B.Console
local CP = B.ControlPoint
N.CPvars = {nil,nil,nil,nil,nil,nil,nil,nil}
local cpv = N.CPvars

N.Store = function()
	cpv = {CP.Num,CP.Mode,CP.LeadCapPlr,CP.LeadCapAmt,CP.Active,CP.Capturing,CP.Blocked,CP.Timer}
end

N.Sync = function(network)
	local count_cpv = #cpv
	local count_cpid = #CP.ID
	local count_cptm = #CP.TeamCapAmt
	count_cpv = network(count_cpv)
	count_cpid = network(count_cpid)
	count_cptm = network(count_cptm)
	for i = 1,count_cpv
		cpv[i] = network(cpv[i])
	end
	for i = 1,count_cpid
		CP.ID[i] = network(CP.ID[i])
	end
	for i = 1,count_cptm
		CP.TeamCapAmt[i] = network(CP.TeamCapAmt[i])
	end
	
	CP.Num = cpv[1]
	CP.Mode = cpv[2]
	CP.LeadCapPlr = cpv[3]
	CP.LeadCapAmt = cpv[4]
	CP.Active = cpv[5]
	CP.Capturing = cpv[6]
	CP.Blocked = cpv[7]
	CP.Timer = cpv[8]
end