local B = CBW_Battle
addHook("PlayerSpawn",function(player) 
	B.InitPlayer(player) 
	B.InitPriority(player)
end)
addHook("TouchSpecial", function(smo,tmo) return B.PlayerTouch(smo,tmo) end,MT_PLAYER)

addHook("PlayerThink", function(player)
	B.SetPlayerPriorityFunc(player)
	if player.mo and player.mo.valid then
		B.DoPriority(player)
	end
end)

//Player against Player
addHook("ShouldDamage", function(target,inflictor,source,damage,other)
	if not(inflictor and inflictor.valid and inflictor.type == MT_PLAYER and inflictor != target)
	return end
	if not(target.player and not(B.MyTeam(target.player,source.player)))
	return end
	if not(B.PlayerCanBeDamaged(target.player) or inflictor.flags2&MF2_SUPERFIRE)
	return end
	return true
end,MT_PLAYER)

//Remove targetdummy false positives
addHook("ShouldDamage", function(target,inflictor)
	if inflictor and inflictor.valid and inflictor.type == MT_TARGETDUMMY then return false end
end,MT_PLAYER)

//Armaggeddon blast
addHook("ShouldDamage", function(target,inflictor,source,damage,other)
	B.DamageTargetDummy(target,inflictor,source,damage,other)
	return false
end,MT_TARGETDUMMY)

//Player was pushed into a death hazard
addHook("MobjDeath",function(target,inflictor,source,damagetype)
	local player = target.player
	if player and (damagetype == DMG_DEATHPIT or damagetype == DMG_CRUSHED)
		and player.pushed_creditplr and player.pushed_creditplr.valid and not(B.MyTeam(player,player.pushed_creditplr))
		then
		P_AddPlayerScore(player.pushed_creditplr,50)
	end
end, MT_PLAYER)