local B = CBW_Battle
addHook("MobjFuse",function(mo) return B.FBombDetonate(mo) end,MT_FBOMB)
addHook("MobjFuse",function(mo) return B.BuzzBuddyFuse(mo) end,MT_BUZZBUDDY)
addHook("MobjMoveCollide",function(bmo,omo) B.BuzzBuddyCollide(bmo,omo) return false end,MT_BUZZBUDDY)
addHook("MobjMoveCollide",function(bmo,omo) B.BombCollide(bmo,omo) return end,MT_FBOMB)
addHook("MobjSpawn",function(mo) return true end,MT_CORK) //Overwrite default behavior so that corks won't damage invulnerable players

addHook("MobjThinker",function(mo) if mo.flags&MF_MISSILE then B.UnderwaterMissile(mo) end end,MT_NULL) //Master underwater check

addHook("MobjThinker",function(mo) B.CharmBeamThinker(mo) end,MT_CHARM)
addHook("MobjThinker",function(mo) B.FBombThink(mo) end,MT_FBOMB)
addHook("MobjThinker",function(mo) B.BuzzBuddyThinker(mo) end,MT_BUZZBUDDY)
addHook("MobjThinker",function(mo) if P_IsObjectOnGround(mo) then P_RemoveMobj(mo) return true end end,MT_ROCKCRUMBLE2)
addHook("ShouldDamage", function(pmo,mo,source) return B.PlayerCorkDamage(pmo,mo,source) end, MT_PLAYER)
addHook("ShouldDamage", function(mo,heart,owner) return B.PlayerHeartCollision(mo,heart,owner) end, MT_PLAYER)
addHook("ShouldDamage",function(pmo,mo,source) return B.CharmBeamCollision(pmo,mo,source) end,MT_PLAYER)
addHook("ShouldDamage",function(pmo,mo,source) return B.PlayerBombDamage(pmo,mo,source) end,MT_PLAYER)
addHook("ShouldDamage",function(mo,inflictor,source) return B.BuzzBuddyDamage(mo,inflictor,source) end,MT_BUZZBUDDY)
addHook("TouchSpecial",function(smo,pmo) return B.BuzzBuddyTouch(smo,pmo) end,MT_BUZZBUDDY)
addHook("MobjThinker",function(mo)
	if not(G_GametypeHasTeams() and mo.target and mo.target.valid and mo.target.player) then return end
	if not(mo.ctfteam) then
		local player = mo.target.player
		mo.ctfteam = player.ctfteam
		mo.color = player.skincolor
		mo.state = S_TEAMFIRE1
	end
end,MT_SPINFIRE)

//Player v player projectile

addHook("ShouldDamage", function(target,inflictor,source,something,damage)
	if inflictor and inflictor.valid
		and (inflictor.info.mass == 0 or inflictor.type <= 651)
		and not(inflictor.type == MT_LHRT or inflictor.type == MT_CORK) 
		then
		return B.BattleProjectileDamage(target,inflictor,source,something,damage)
	end
end,MT_PLAYER)