local B = CBW_Battle

addHook("PreThinkFrame", function()
	B.PriorityCheckSkinSet()
	for player in players.iterate
		//History
		if player.versusvars == nil then
			player.buttonhistory = player.cmd.buttons
			B.InitPlayer(player)
			player.versusvars = true
		end
		//Support mobjs
		B.SpawnTargetDummy(player)
	end
end)

addHook("ThinkFrame",function()	
	for player in players.iterate
		B.PlayerThinkFrame(player)
	end
	B.TeamBattleScore()
	B.TagVictorCheck()
end)

addHook("PostThinkFrame",function()
	B.NetVars.Store()
end)

addHook("NetVars",function(network)
	B.NetVars.Sync(network)
end)